;
;                            >>> I.V.I. 256 <<<
;                   "Incidental Vertical Interlace"
;                (c) 1992-02-17 by incident (and by JAC!)
;             (r) 1992-19-02 now I know why it works at least
;       (r) 2017-12-04 in 256 bytes for SillyVenture 2k17 in Gdansk
;
;       You have to be a coder to realize,what incidents can do :-)
;	Transmission put $00 $11 $00 $00 from Dtrans at $0000 ... 
;       and I just forgot to switch off the screen properly .... BAZ!


opcode_lax_abs	= $af
opcode_sax_abs	= $8f

colbk	= $d01a

skrest	= $d20f

dlistl	= $d402
dlisth	= $d403
wsync	= $d40a
vcount	= $d40b

; Zero page
y_count		= $e1
color_chroma	= $e2
color_offset	= $e3
sax_mask	= $e4
text_index	= $e5

; Generated code
code1	= $2000
code2	= $4202

;===============================================================
	.macro m_info	;Works with ranges like ".PROC", ".LOCAL"
	.print ":1: " , :1, " - ", :1 + .len :1 -1, " (", .len :1,")"
	.endm

	opt f+

	org $8000+24

	.proc main

	jsr generate
	inc 559			;Turn $22 into $23 for wide playfield DMA

	.proc main_loop
	lda #$03
	sta skrest
	jsr sync_dl1
	jsr code1

	dec colbk
;	sta wsync
	lda #<dl2
	sta dlistl
	
	lda #$3b
	jsr sync_dl1
	jsr code2

	lda 19			;Slow clock
	and #6
	tay

	lda 20			;Fast clock
	and #3
	pha			;Push for volumne

	eor #7
	sta $d404
	cmp #7
	bne no_inc		;<C>=1 if not taken

	inc 709			;Increment brighness and character counter
	.byte opcode_lax_abs,a(709)
	sta dl2+1
	and #127
	bne no_next_mask
;	sec			;See CMP above, <C>=1 if not taken
	rol sax_mask
stop	bcs stop

no_next_mask
	txa
	lsr
	lsr
	tax
	lda text,x
	and #3
	tax
	lda notes,x
	sta $d200,y

no_inc	pla			;Pull for volumne
	asl
	eor #$af
	sta $d201,y
	bne main_loop


dl2	.byte $52,<text,>text	;Text DL and the next byte must be an ANTIC blank like $00/$10/$20..$f0
dl1	.byte $00,$01,a(dl1)	;Blank DL with only a JMP

	.local notes
	.byte 243,193,162,121	;C1,G1,E1,C2
	.endl


	.proc sync_dl1		;IN: <A>=target_vcount, OUT: <A>=<dl1>, <X>=sax_mask
	ldy #>dl1
	ldx sax_mask
wait_vcount1
	cmp vcount
	bne wait_vcount1
	sty dlisth
	lda #<dl1
	sta wsync
	sta dlistl
	rts

	.endp

	.endp

	.proc generate
	jsr generate_one
	lda #$70
	sta color_offset
generate_one
	lda #100
	sta y_count

	.proc loop_y
	ldy #17			;Beware, <Y> is the x counter!

	.proc loop_x

	.proc copy_text		;Placed here so it is simply called often enough
	ldx text_index
	lda text,x
	sta text+scroll_offset,x
	inc text_index
	.end			;End of copy_text

	tya
	asl
	adc y_count
	tax
	adc color_offset
	and #$f0
	sta color_chroma
	txa
	and #$0f
	cmp #$08
	scc 
	eor #$0f
	asl
	ora color_chroma

	jsr poke_sta_d01a

	dey
	bne loop_x
	.endp

	lda #$a5		;LDA <X=$d0> to eat 3 cyles
	jsr poke2
	dec y_count
	bne loop_y
	.endp

	tya			;<Y>:=0 => <A>:=0
	sta 710
	sta $d208
	jsr poke_sta_d01a
	lda #$60
	bne poke

poke_sta_d01a
	tax
	lda #$a9		;LDA #imm
	jsr poke2
	lda #opcode_sax_abs	;SAX abs
	jsr poke
	lda #<colbk
	ldx #>colbk

poke2	jsr poke
	txa
poke	sta code1
	inw poke+1
	rts

	.endp			;End of generate

	.endp			;End of main

	scroll_offset = 18
	.local text
;	.byte "01234567890123456789"
	.byte "SillyVenture 2017",$40
	.endl
	
	m_info text